#include <stdio.h>
#define n1 1900
#define n2 1250
char head[36][80];
unsigned char c[n2][n1];
FILE *fp;

#define LWORD unsigned long
#define WORD  unsigned short
#define BYTE  unsigned char

// GIF-parameter
unsigned char SuffixTable[4999], ByteBuf[2592], BlockBuf[256];
short EncodeTable[4999], PrefixTable[4999];      // have in common_use
LWORD TempCode;
short Code, RunBits, ByteCount, ShiftBits;

FillBlockBuf()
{
  TempCode |= (unsigned int)Code << ShiftBits;
  ShiftBits += RunBits;
  while(ShiftBits >= 8)  {
    BlockBuf[++ByteCount] = TempCode & 0x00FF;
    if(ByteCount == 255){
      BlockBuf[0] = (unsigned char)ByteCount;
      fwrite(BlockBuf, 1, ByteCount+1, fp);
      ByteCount = 0;
    }
    TempCode >>= 8;
    ShiftBits -= 8;
  }
}

togif(c256,m1,m2)
unsigned char *c256;
int m1,m2;
{
short Encode, MaxCodeSize, Width, Height, Dots, Rows;
short PrefixCode, SuffixCode, RandomIndex, Val;
short head1[7]={0x4947,0x3846,0x6137,0,0,0xf7,0};
short head2[5]={0,0,0,0,0x800};
LWORD jj;
  int i;

  head1[3]=head2[2]=Width=m1;
  head1[4]=head2[3]=Height=m2;
  fwrite(head1,1,13,fp);
  for(i=0;i<256;i++){
    ByteBuf[0]=ByteBuf[1]=ByteBuf[2]=i;
    fwrite(ByteBuf,1,3,fp);
  }
  fputc(0x2c,fp);
  fwrite(head2,2,5,fp);
  ByteCount = ShiftBits = TempCode = 0;

  Encode = 258;  RunBits = 9;  MaxCodeSize =512;
  for(i = 0; i < 4999; i++) EncodeTable[i] = 0;
  Code = 256;
  FillBlockBuf();
  for(Rows = 0; Rows < Height; Rows++)  {
    jj=(m2-1-Rows)*m1;
    for(i=0;i<m1;i++)ByteBuf[i]=c256[jj++];
    if(Rows == 0) { PrefixCode = ByteBuf[0];  Dots = 1; }
    else Dots = 0;
    while( Dots < Width)  {
      SuffixCode = ByteBuf[Dots++];
      RandomIndex = PrefixCode ^ (SuffixCode << 4);
      if(RandomIndex == 0)  Val = 1;
      else Val = 4999 - RandomIndex;
      while(1)  {
        if(EncodeTable[RandomIndex] == 0)  {
          Code = PrefixCode;
          FillBlockBuf();
          if(Encode == 4096)  {
            Code = 256;
            FillBlockBuf();
            Encode = 258;  RunBits = 9;  MaxCodeSize =512;
            for(i = 0; i < 4999; i++) EncodeTable[i] = 0;
          }
          else  {
            if(Encode == MaxCodeSize)  {
              MaxCodeSize <<= 1;
              RunBits++;
            }
            PrefixTable[RandomIndex] = PrefixCode;
            SuffixTable[RandomIndex] = (unsigned char)SuffixCode;
            EncodeTable[RandomIndex] = Encode++;
          }
          PrefixCode = SuffixCode;
          break;
        }
        if(PrefixTable[RandomIndex] == PrefixCode &&
           SuffixTable[RandomIndex] == SuffixCode)  {
          PrefixCode = EncodeTable[RandomIndex];
          break;
        }
        else  {
          RandomIndex -= Val;
          if(RandomIndex < 0)  RandomIndex += 4999;
        }
      }
    }
  }
  Code = PrefixCode;
  FillBlockBuf();
  Code = 257;
  FillBlockBuf();
  if(ShiftBits > 0 || ByteCount > 0)   {
    BlockBuf[++ByteCount] = TempCode & 0x00FF;
    BlockBuf[0] = (unsigned char)ByteCount;
    fwrite(BlockBuf, 1, ByteCount+1, fp);
    ByteCount = 0;
  }
  fputc(0, fp);  fputc(';', fp);
}

main(int ac,char **av)
{
  int i,j,k;
  int ch[4];
  int ch2[7]={351,344,4839,3560,2240,2354,1828};  // S L star mi duo fen bu
  if(ac<2){ printf("\n\t show SL status ******\n");
            printf("\n\t Usage: dd5 !\n\n");
            exit(0);
  }
  fp=fopen("dd4.fit","rb");   // max value: 202
  fread(head,36,80,fp);  fread(c,n1,n2,fp); fclose(fp);
  fp=fopen("uslall.fit","wb"); 
  xchinese(c,n1,860,1200,ch2,7,1,0,0);        // SL
  for(j=50;j<=1154;j+=1104)for(i=50;i<=1850;i++)c[j][i]=150;
  for(j=50;j<=1154;j++)for(i=50;i<=1850;i+=1800)c[j][i]=150;

  for(j=104;j<=1154;j+=100)for(i=50;i<=1850;i++)c[j][i]=100;
  for(j=50;j<=1154;j++)for(i=50;i<=1850;i+=75)c[j][i]=100;
  
  for(i=24,j=0;i>=0;i-=2,j++){ ch[2]=203;
    ch[0]=i/10+1149; ch[1]=i%10+1149; 
    xchinese(c,n1,30+j*150,10,ch,3,1,0,-8);
    xchinese(c,n1,30+j*150,1160,ch,3,1,0,-8);
  }  
  for(i=-20;i<=80;i+=10){ ch[0]=1144; ch[3]=1361;
    j=i; if(j<0){ j=-j; ch[0]=1146; }
    ch[1]=j/10+1149; ch[2]=j%10+1149; 
    xchinese(c,n1,5,i*10+295,ch,4,1,0,-12);
    xchinese(c,n1,1855,i*10+295,ch,4,1,0,-12);
  }  
  fwrite(head,36,80,fp);  fwrite(c,n1,n2,fp); fclose(fp);
  fp=fopen("uslall.gif","wb");
  togif(c,n1,n2);
}

int open_han24=0;
FILE *fhan24;
unsigned char h24[8178][72],b24[24][24];
t_ch_24(ii,b24)
int ii;
unsigned char b24[24][24];
{
  int i,j,k,b;
  unsigned char *p;
  k=ii%100; if(k>94 || k==0)return(0);
  k+=(ii/100-1)*94; if(k<0 || k>8178)return(0);
  p=h24[k-1];
  for(j=0;j<24;j++)for(i=1;i<=3;i++){ b=*p++; 
    for(k=1;k<=8;k++){ b24[23-j][i*8-k]=b%2; b/=2; }
  }
}

xchinese(map,m1,x,y,ch,cn,j1,j2,j3)
int m1,x,y,cn,*ch,j1,j2,j3;
unsigned char map[][m1];
// x,y position  ! world coordination
// ch(n)         ! n chinese_char. 
// j1            ! 1~6, size
// j2            ! 0, 90, -90, direct
// j3            ! gap
{
  int i,j,k,l;
  if(open_han24==0){ open_han24=1;
    fhan24=fopen("/vega2/pgplot/han.24","rb");
    if(fhan24==0){ printf(" han.24 not found!\n"); exit(0); }
    fread(h24,8178,72,fhan24); fclose(fhan24);
  }
  for(i=0;i<cn;i++){
    t_ch_24(ch[i],b24);
    l=x+i*(24+j3);   
    for(j=0;j<24;j++)for(k=0;k<24;k++)if(b24[j][k])map[j+y][k+l]=255;
  }
}
